﻿/**
 * Hi.
 * 
 * I wrote this utility in under an hour.  I'm not bragging.  Quite the opposite: I'm explaining why it sucks.
 * However!  It should get the job done.  I just renamed 22,000+ files in my Digital Juice library in about 3 minutes,
 * much thanks to the efforts of LiquidBlasted over at this URL who went to the trouble of creating Excel files
 * of all the tracks:
 * 
 * http://sound.stackexchange.com/questions/20728/importing-digital-juice-sound-fx-iv-metadata-to-audiofinder
 * 
 * Without those XLS files (which are easy enough to save as CSV), I would have been stuck using the Juicer app, too.
 * 
 * This app is very simple.  It does these three things:
 * 
 *     1)  Reads all file names and track names from a CSV file into a Dictionary.
 *     2)  Gets all the files in a directory (and subdirectories, if applicable) that match the pattern ?????_SFX*
 *     3)  Iterates all of those files, and if the file name (minus extension) matches the key in the dictionary (which
 *         is the file name from the CSV) then it renames the file to the dictionary value (which is the track name
 *         from the CSV) + the original file name (e.g. 00001_SFX.mp3). 
 *
 * That's pretty much it.
 *  
 * If you have any problems, make sure that the CSV file has headers and that the 4th column contains the file name
 * and the 7th column contains the track name.  If that's not how your CSV is formatted, you can re-order the columns
 * in Excel and re-export, or simply change the source code.
 * 
 * I RECOMMEND YOU _COPY_ TEN OR SO AUDIO FILES INTO A TEMPORARY DIRECTORY AND TEST ON THAT.
 * 
 * IF THE CSV FILE IS NOT CORRECTLY FORMATTED THIS PROGRAM COULD VERY WELL GIVE _EVERY_ _SINGLE_ _FILE_ IN YOUR DIGITAL JUICE
 * LIBRARY A STUPID AND USELESS FILE NAME.
 * 
 * SO PLEASE, PLEASE, PLEASE, TEST IT FIRST!
 * 
 * EVEN AFTER YOU TEST IT ON SOME TEMPORARY FILES, FIRST TRY RUNNING IT ON A REAL SUBDIRECTORY SUCH AS
 *      \Musical\Sets\AcousticSet1
 * OR SOMETHING.  THEN AFTER THAT WORKS WITHOUT MESSING UP YOUR SHIT, GO FOR IT ON THE ENTIRE LIBRARY!
 * 
 * Sorry for all the yelling, but this is a really stripped down program that doesn't bother trying not to mess
 * you up.  I'd really hate to find out that I caused you to hose your entire library.  Well, at least you still have the
 * DVDs as a backup.  Unless you lost them.  Which is why I was yelling, because I lost mine and I'd hate to lose the data, too.
 * 
 * Of course, you can always improve this program.  :)
 * 
 * LICENSE:
 * 
 * This was made by s.co.tt (that's my website and my name, though I'm not crazy enough to change my real name to have the dots.. 
 * though maybe I should).
 * 
 * This program has no real license.  Do whatever you want.  Print out the source code, fold it into an ironic hat and sell it on
 * Etsy for all I care.
 * 
 * The only thing I ask, out of politeness more than any enforcable legal thing, is that if you make any improvements to
 * the code, please let me know:
 * 
 *         Email : scott@s.co.tt
 *          Blog : http://s.co.tt
 *            FB : s.co.tt
 * Homing Pigeon : {Skwak, skwak, skwak dot skwak)
 * 
 * Also, please don't remove this rambling description of the app from the top of this thing.  Not that this will
 * be even slightly popular or ever downloaded once, because who cares about Digital Juice anyway and I'm wasting my
 * time, but whatever.
 * 
 * Oh yeah, I wrote this in .NET, so sorry if you have a Mac or a Linux.  Unless you have Mono (not the disease, the .NET
 * port) or the MS .NET for Mac/Linux preview, then I guess you can re-compile with that.
 * 
 * Seriously though, I should've written this in Java for cross-platform blahblahblah, but I never get a chance to write
 * C# apps anymore.  So this was fun for me, even if it sucks for you.  I guess you could port this to Java, which
 * is to say just re-write it.
 * 
 * Hell, this description of what's going on is now probably longer than all the code.  If you implement this in Java and send
 * me a copy to put on my site I'll send you a sandwich by snail mail.  It won't stay good because I'm not going to use
 * ice packs or anything, so you can pretty much just throw it right out.  But this is one of those it's-funny-because-he-actually-sent-it
 * type of deals.
 * 
 * This includes "A Fast CSV Reader" from LumenWorks / Sebastien Lorion.  All credit for that library goes to its respective author(s).
 * More information is available here: http://www.codeproject.com/Articles/9258/A-Fast-CSV-Reader
 **/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Collections;
using LumenWorks.Framework.IO.Csv;

namespace DigitalJuiceRenamer
{
    class Program
    {
        static void Main(string[] args)
        {
            if (args.Length != 2)
            {
                Console.WriteLine("Usage: DigitalJuiceRenamer.exe [CSV File] [Top Level Directory]");
                Console.WriteLine();
                Console.WriteLine("Here's the deal:  The CSV file must have the original file name");
                Console.WriteLine("in the 4th column.  It must have the track name in the 7th col.");
                Console.WriteLine("It will only rename files that match the file name field (w/o");
                Console.WriteLine("the extension.  So it can be re-run over the same directory");
                Console.WriteLine("structure more than once.");
                return;
            }

            if (!File.Exists(args[0]))
            {
                Console.WriteLine("The CSV file specified does not exist:");
                Console.WriteLine(args[0]);
                return;
            }

            if (!Directory.Exists(args[1]))
            {
                Console.WriteLine("The directory specified does not exist:");
                Console.WriteLine(args[1]);
                return;
            }

            Console.Write("Reading CSV File...");

            StreamReader sr = new StreamReader(args[0]);

            CsvReader csv = new CsvReader(sr, true);

            Dictionary<String, String> dictCSV = new Dictionary<String, String>();

            try
            {
                // This will fail because the CSV file I have contains dupe headers.  No big deal.
                string[] headers = csv.GetFieldHeaders();
            }
            catch (Exception ex) { }

            int iRecs = 0;
            while (csv.ReadNextRecord())
            {
                iRecs++;
                if (csv.FieldCount >= 7)
                    dictCSV.Add(csv[3], csv[6]);
            }

            sr.Close();

            Console.WriteLine(" DONE! (Stored {0} of {1} records.)", dictCSV.Count, iRecs);

            int iSuccess = 0;
            int iFailed = 0;

            Console.Write("Getting files...");

            string[] sFiles = Directory.GetFiles(args[1], "?????_SFX*", SearchOption.AllDirectories);

            Console.WriteLine("DONE! (Got {0} files.)\r\nRenaming files...", sFiles.Length);

            for (int i = 0; i < sFiles.Length; i++)
            {
                string sFileName = Path.GetFileNameWithoutExtension(sFiles[i]);

                if (dictCSV.ContainsKey(sFileName))
                {
                    string sNewFileName = Path.GetDirectoryName(sFiles[i]) + @"\" + dictCSV[sFileName] + "_" + sFileName + Path.GetExtension(sFiles[i]);
                    try
                    {
                        File.Move(sFiles[i], sNewFileName);
                        iSuccess++;
                    }
                    catch (IOException ex)
                    {
                        Console.WriteLine("IOException moving file ( " + sFiles[i] + " ) to ( " + sNewFileName + " ):\r\n" + ex.Message);
                        iFailed++;
                    }
                    catch (Exception ex)
                    {
                        Console.WriteLine("Exception moving file ( " + sFiles[i] + " ) to ( " + sNewFileName + " ):\r\n" + ex.Message);
                        iFailed++;
                    }
                }
            }

            Console.WriteLine(" DONE! (Success: {0}, Failed: {1}.)", iSuccess, iFailed);

            Console.WriteLine("FINISHED with {0} files renamed out of {1} files total, and {2} CSV records total.", iSuccess, sFiles.Length, iRecs);

            Console.ReadLine();
        }
    }
}
